#ifndef PERFECT_GAS_HPP
#define PERFECT_GAS_HPP

#include <scheme/IDiscreteFunction.hpp>

namespace perfect_gas
{
std::shared_ptr<IDiscreteFunction> soundSpeed(const std::shared_ptr<const IDiscreteFunction>& rho,
                                              const std::shared_ptr<const IDiscreteFunction>& p,
                                              const std::shared_ptr<const IDiscreteFunction>& gamma);

std::shared_ptr<IDiscreteFunction> epsilonFromRhoPGamma(const std::shared_ptr<const IDiscreteFunction>& rho,
                                                        const std::shared_ptr<const IDiscreteFunction>& p,
                                                        const std::shared_ptr<const IDiscreteFunction>& gamma);

std::shared_ptr<IDiscreteFunction> pFromRhoEpsilonGamma(const std::shared_ptr<const IDiscreteFunction>& rho,
                                                        const std::shared_ptr<const IDiscreteFunction>& epsilon,
                                                        const std::shared_ptr<const IDiscreteFunction>& gamma);

// This is a temporary function
// Todo: TO REMOVE
std::shared_ptr<IDiscreteFunction> totalEnergyFromEpsilonU(const std::shared_ptr<const IDiscreteFunction>& epsilon,
                                                           const std::shared_ptr<const IDiscreteFunction>& u);

// This is a temporary function
// Todo: TO REMOVE
std::shared_ptr<IDiscreteFunction> epsilonFromTotalEnergyU(const std::shared_ptr<const IDiscreteFunction>& E,
                                                           const std::shared_ptr<const IDiscreteFunction>& u);

}   // namespace perfect_gas

#endif   // PERFECT_GAS_HPP
